var version = "1.1.0.0";

var defaultServer = "katzner.de";
var maxHistory	= 120;
var refreshRate	= 1000;

var server;
var showServer;
var historyType;

var values = new Array();
var maxValue = 1;

var versionPattern = new RegExp("^\\d+(\\.\\d+)*$");

function ping() {
	var locator = new ActiveXObject("WbemScripting.SWbemLocator");
	var service = locator.ConnectServer(null, "root\\cimv2");
	var resultSet = service.ExecQuery("SELECT * FROM Win32_PingStatus WHERE Timeout = 1000 AND Address = '" + server + "'");
	return Number(resultSet.ItemIndex(0).ResponseTime);
}

function refresh() {
	var time = ping();
	if (time > maxValue) maxValue = time;
	if (values.push(time) > maxHistory) {
		if (values.shift() == maxValue) {
			maxValue = 1;
			for (var i=0; i<values.length; i++) {
				if (values[i] > maxValue) maxValue = values[i];
			}
		}
	}

	var path;
	switch (historyType) {
	case 0: // polygon
		path = "m 0,61 l";
		for (var x=0; x<values.length; x++) {
			var y = 61 - Math.floor((51 * values[x]) / maxValue);
			path += " " + x + "," + y;
		}
		path += " " + (values.length - 1) + ",61 x e";
		break;
	default: // line
		path = "";
		for (var x=0; x<values.length; x++) {
			var y = 61 - Math.floor((51 * values[x]) / maxValue);
			path += " m " + x + ",61 l " + x + "," + y;
		}
		path += " e";
	}

	document.getElementById("text1").innerText = showServer ? server : "";
	document.getElementById("text2").innerText = time + " / " + maxValue;
	graph.path = path;
}

function onLoad() {
	server = System.Gadget.Settings.readString("server");
	if (server == "") server = defaultServer;

	showServer = System.Gadget.Settings.readString("showServer");
	if (showServer == "") showServer = true;

	historyType = System.Gadget.Settings.read("historyType");
	if (historyType == "") historyType = 0;

	System.Gadget.settingsUI = "settings.html";
	window.setInterval("refresh();", refreshRate);
}

// --------------------------------------------------------------------------

function checkForUpdate() {
	var XMLDoc = new ActiveXObject("Microsoft.XMLDOM");
	XMLDoc.async = false;
	if (XMLDoc.load("http://sascha.katzner.de/pinghistory_version.xml")) {
		if (XMLDoc.parseError.errorCode == 0) {
			versionData.innerText = version;
			var latestVersion = XMLDoc.selectSingleNode("/rss/channel/item/title").text;
			if (versionPattern.test(latestVersion)) {
				latestVersionData.innerText = latestVersion;
				if (version != latestVersion) {
					versionData.style.color = "#F00";
					versionData.innerHTML += outDated;
				}
			}
		}
	}
}

function onSettingsClosed(event) {
	if (event.closeAction == event.Action.commit) {
		System.Gadget.Settings.writeString("server", serverText.value);
		System.Gadget.document.parentWindow.server = serverText.value;

		System.Gadget.Settings.writeString("showServer", showServerCheckbox.checked);
		System.Gadget.document.parentWindow.showServer = showServerCheckbox.checked;

		System.Gadget.Settings.writeString("historyType", historyTypeSelect.selectedIndex);
		System.Gadget.document.parentWindow.historyType = historyTypeSelect.selectedIndex;
	}
}

function loadSettings() {
	var server = System.Gadget.Settings.readString("server");
	if (server == "") server = defaultServer;
	serverText.value = server;

	var showServer = System.Gadget.Settings.readString("showServer");
	if (showServer == "") showServer = true;
	showServerCheckbox.checked = showServer;

	var historyType = System.Gadget.Settings.read("historyType");
	if (historyType == "") historyType = 0;
	historyTypeSelect.selectedIndex = historyType;

	System.Gadget.onSettingsClosed = onSettingsClosed;

	checkForUpdate();
}
